aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ramips/base-files/lib
diff options
context:
space:
mode:
authorAdrian Schmutzler <freifunk@adrianschmutzler.de>2019-10-22 12:37:13 +0200
committerAdrian Schmutzler <freifunk@adrianschmutzler.de>2019-11-03 00:26:17 +0100
commit19724e28c81e3ff642f09c49f612cd147c54a697 (patch)
tree278c45d3b1563cee6108e65c3b5856dbab304062 /target/linux/ramips/base-files/lib
parent0975c35b83a632f9662d1944307f87da9db06154 (diff)
downloadupstream-19724e28c81e3ff642f09c49f612cd147c54a697.tar.gz
upstream-19724e28c81e3ff642f09c49f612cd147c54a697.tar.bz2
upstream-19724e28c81e3ff642f09c49f612cd147c54a697.zip
ramips: split base-files into subtargets
While most of the target's contents are split into subtargets, the base-files are maintained for the target as a whole. However, OpenWrt already implements a mechanism that will use (and even prefer) files in the subtargets' directories. This can be exploited to make several scripts subtarget-specific and thus save some space. In certain cases, keeping files in parent (=target) base-files was more convenient, and thus no splitting was performed for those. Note that this will increase overall code lines, but reduce code per subtarget. base-files ipk size reduction: master (mt7621) 60958 B split (mt7620) 46358 B (- 14.3 kiB) split (mt7621) 48759 B (- 11.9 kiB) split (mt76x8) 44948 B (- 15.6 kiB) split (rt288x) 43508 B (- 17.0 kiB) split (rt305x) 45616 B (- 15.0 kiB) split (rt3883) 44176 B (- 16.4 kiB) Run-tested on: GL.iNet GL-MT300N-V2 (mt76x8) D-Link DWR-116 (mt7620) Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de>
Diffstat (limited to 'target/linux/ramips/base-files/lib')
-rw-r--r--target/linux/ramips/base-files/lib/preinit/04_handle_checksumming56
-rwxr-xr-xtarget/linux/ramips/base-files/lib/upgrade/platform.sh54
-rw-r--r--target/linux/ramips/base-files/lib/upgrade/ubnt.sh78
3 files changed, 0 insertions, 188 deletions
diff --git a/target/linux/ramips/base-files/lib/preinit/04_handle_checksumming b/target/linux/ramips/base-files/lib/preinit/04_handle_checksumming
deleted file mode 100644
index 8f741faf9d..0000000000
--- a/target/linux/ramips/base-files/lib/preinit/04_handle_checksumming
+++ /dev/null
@@ -1,56 +0,0 @@
-#!/bin/sh
-
-# Netgear WNCE2001 has does a checksum check on boot and goes into recovery
-# tftp mode when the check fails. Initializing the JFFS2 partition triggers
-# this, so we make sure to zero checksum and size to be checksummed before
-# that happens, so this needs to run very early during boot.
-
-do_checksumming_disable() {
- . /lib/functions.sh
-
- local board=$(board_name)
-
- case "$board" in
- netgear,wnce2001)
- echo "Board is WNCE2001, updating checksum partition..."
- local zeroes=/dev/zero
- local tmpfile=/tmp/wnce2001_checksum
- local partname=checksum
- local mtd=$(find_mtd_part $partname)
- dd if=$mtd of=$tmpfile bs=80 count=1 2>/dev/null
- signature=$(dd if=$tmpfile bs=1 skip=24 count=20 2>/dev/null)
- checksum=$(dd if=$tmpfile bs=1 count=4 2>/dev/null | hexdump -v -n 4 -e '1/1 "%02x"')
- if [ "$signature" != "RT3052-AP-WNCE2001-3" ]; then
- echo "Signature of checksum partition is wrong, bailing."
- return 0
- fi
- if [ "$checksum" != "00000000" ]; then
- echo "Checksum is set, zeroing."
- # zero out checksum
- dd if=$zeroes of=$tmpfile conv=notrunc bs=1 seek=0 count=4 2>/dev/null
- # zero out bytecount to be checksummed
- dd if=$zeroes of=$tmpfile conv=notrunc bs=1 seek=60 count=4 2>/dev/null
- mtd write $tmpfile $partname
- else
- echo "Checksum is already zero, nothing to do."
- fi
- ;;
- asus,rt-n56u)
- echo "Board is ASUS RT-N56U, replacing uImage header..."
- local firmware_mtd=$(find_mtd_part firmware)
- local rootfs_mtd=$(find_mtd_part rootfs)
- local rootfs_data_mtd=$(find_mtd_part rootfs_data)
- local rootfs_len=$(grep \"rootfs\" /proc/mtd | awk -F' ' '{print "0x"$2}')
- local rootfs_data_len=$(grep \"rootfs_data\" /proc/mtd | awk -F' ' '{print "0x"$2}')
- local offset=$(echo "$rootfs_len $rootfs_data_len 0x40" | awk -F' ' '{printf "%i",$1-$2-$3}')
- local signature=$(dd if=$rootfs_mtd skip=$offset bs=1 count=4 2>/dev/null | hexdump -v -n 4 -e '1/1 "%02x"')
- if [ "$signature" = "27051956" ]; then
- dd conv=notrunc if=$rootfs_mtd skip=$offset of=$firmware_mtd bs=1 count=64 2>/dev/null
- fi
- ;;
- esac
-
- return 0
-}
-
-boot_hook_add preinit_main do_checksumming_disable
diff --git a/target/linux/ramips/base-files/lib/upgrade/platform.sh b/target/linux/ramips/base-files/lib/upgrade/platform.sh
deleted file mode 100755
index 03e994dfa4..0000000000
--- a/target/linux/ramips/base-files/lib/upgrade/platform.sh
+++ /dev/null
@@ -1,54 +0,0 @@
-#
-# Copyright (C) 2010 OpenWrt.org
-#
-
-PART_NAME=firmware
-REQUIRE_IMAGE_METADATA=1
-
-platform_check_image() {
- return 0
-}
-
-platform_do_upgrade() {
- local board=$(board_name)
-
- case "$board" in
- mikrotik,rb750gr3|\
- mikrotik,rbm11g|\
- mikrotik,rbm33g)
- [ -z "$(rootfs_type)" ] && mtd erase firmware
- ;;
- asus,rt-ac65p|\
- asus,rt-ac85p)
- echo "Backing up firmware"
- dd if=/dev/mtd4 bs=1024 count=4096 > /tmp/backup_firmware.bin
- dd if=/dev/mtd5 bs=1024 count=52224 >> /tmp/backup_firmware.bin
- mtd -e firmware2 write /tmp/backup_firmware.bin firmware2
- ;;
- esac
-
- case "$board" in
- asus,rt-ac65p|\
- asus,rt-ac85p|\
- hiwifi,hc5962|\
- netgear,r6220|\
- netgear,r6260|\
- netgear,r6350|\
- netgear,r6850|\
- xiaomi,mir3g|\
- xiaomi,mir3p)
- nand_do_upgrade "$1"
- ;;
- tplink,archer-c50-v4)
- MTD_ARGS="-t romfile"
- default_do_upgrade "$1"
- ;;
- ubiquiti,edgerouterx|\
- ubiquiti,edgerouterx-sfp)
- platform_upgrade_ubnt_erx "$1"
- ;;
- *)
- default_do_upgrade "$1"
- ;;
- esac
-}
diff --git a/target/linux/ramips/base-files/lib/upgrade/ubnt.sh b/target/linux/ramips/base-files/lib/upgrade/ubnt.sh
deleted file mode 100644
index 748ec8e628..0000000000
--- a/target/linux/ramips/base-files/lib/upgrade/ubnt.sh
+++ /dev/null
@@ -1,78 +0,0 @@
-#
-# Copyright (C) 2015 OpenWrt.org
-#
-
-. /lib/functions.sh
-#Note: this code also uses some functions from nand.sh, but it is expected to be run by nand.sh, so we are not
-#sourcing it explicitly here
-
-UBNT_ERX_KERNEL_INDEX_OFFSET=160
-
-ubnt_get_target_kernel() {
- local factory_mtd=$1
- local current_kernel_index=$(hexdump -s $UBNT_ERX_KERNEL_INDEX_OFFSET -n 1 -e '/1 "%X "' ${factory_mtd})
-
- if [ $current_kernel_index == "0" ]; then
- echo 'kernel2'
- elif [ $current_kernel_index == "1" ]; then
- echo 'kernel1'
- fi
-}
-
-ubnt_update_target_kernel() {
- local factory_mtd=$1
- local kernel_part=$2
-
- local new_kernel_index
- if [ $kernel_part == "kernel1" ]; then
- new_kernel_index="\x00"
- elif [ $kernel_part == "kernel2" ]; then
- new_kernel_index="\x01"
- else
- echo 'Unknown kernel image index' >&2
- return 1
- fi
-
- if ! (echo -e $new_kernel_index | dd of=${factory_mtd} bs=1 count=1 seek=$UBNT_ERX_KERNEL_INDEX_OFFSET); then
- echo 'Failed to update kernel bootup index' >&2
- return 1
- fi
-}
-
-platform_upgrade_ubnt_erx() {
- local factory_mtd=$(find_mtd_part factory)
- if [ -z "$factory_mtd" ]; then
- echo "cannot find factory partition" >&2
- exit 1
- fi
-
- local kernel_part="$(ubnt_get_target_kernel ${factory_mtd})"
- if [ -z "$kernel_part" ]; then
- echo "cannot find factory partition" >&2
- exit 1
- fi
-
- # This is a global defined in nand.sh, sets partition kernel will be flashed into
- CI_KERNPART=${kernel_part}
-
- #Remove volume possibly left over from stock firmware
- local ubidev="$( nand_find_ubi "$CI_UBIPART" )"
- if [ -z "$ubidev" ]; then
- local mtdnum="$( find_mtd_index "$CI_UBIPART" )"
- if [ -z "$mtdnum" ]; then
- echo "cannot find ubi mtd partition $CI_UBIPART" >&2
- exit 1
- fi
- ubiattach -m "$mtdnum"
- sync
- ubidev="$( nand_find_ubi "$CI_UBIPART" )"
- fi
- if [ -n "$ubidev" ]; then
- local troot_ubivol="$( nand_find_volume $ubidev troot )"
- [ -n "$troot_ubivol" ] && ubirmvol /dev/$ubidev -N troot || true
- fi
-
- ubnt_update_target_kernel ${factory_mtd} ${kernel_part} || exit 1
-
- nand_do_upgrade "$1"
-}